
package
{
	import flash.events.NativeDragEvent;
	import flash.desktop.TransferableData;
	import flash.desktop.DragManager;
	import flash.desktop.TransferableFormats;
	import mixi.MixiClient;
	import mixi.MixiClientEvent;
	import mx.controls.Alert;
	import mx.controls.Text;
	import mx.controls.listClasses.ListData;
	import mx.controls.ComboBox;
	import mx.charts.AreaChart;
	import mx.controls.Image;
	import flash.events.MouseEvent;
	import flash.display.DisplayObject;
	import flash.filesystem.File;
	
	
	public class MainWindowHandler
	{
		private var window: MixiPhotoManager;
		private var mixiClient: MixiClient;

		public function MainWindowHandler(window: MixiPhotoManager) {
			this.window     = window;
			this.mixiClient = new MixiClient(window);
		}

		public function init(): void
		{
			window.addEventListener(NativeDragEvent.NATIVE_DRAG_ENTER, onDragEnter);
			window.addEventListener(NativeDragEvent.NATIVE_DRAG_DROP, onDragDrop);

			mixiClient.addEventListener(MixiClientEvent.LOGIN_COMPLETE, onLogin);
			mixiClient.addEventListener(MixiClientEvent.LISTPHOTOLIB_COMPLETE, onListPhotoLib);
			mixiClient.doLogin();
			window.status = "ログイン処理中 ...";
		}

		public function onLogin(e:MixiClientEvent):void {
			window.status = "ログイン完了";
			loadPhotoLibraryList();
		}
		
		public function onListPhotoLib(e:MixiClientEvent):void {
			window.status = "一覧取得完了";
			
			var list:Array = e.msg as Array;
			var cbData:Array = new Array();
			for(var i:int = 0; i < list.length; ++i) {
				var info:Array = list[i];
				cbData.push({data:info["url"], label:info['name']});
			}
			window.libs.dataProvider = cbData;
		}

		private function loadPhotoLibraryList():void {
			mixiClient.getPhotoLibList();
		}
 	
 	
 	
 	
 	        public function onDragEnter(e:NativeDragEvent):void {
            //転送データの取得
            var data:TransferableData=e.transferable;
            
            //転送データのフォーマットのチェック
            if (data.hasFormat(TransferableFormats.URL_FORMAT)    ||
                data.hasFormat(TransferableFormats.FILE_LIST_FORMAT)){

                //ドラッグ&ドロップを許可
                DragManager.acceptDragDrop(window);
            }  
        }
            
        public function onDragDrop(e:NativeDragEvent):void {
           //転送データ     
            var data:TransferableData=e.transferable;

            //URL
            if(data.hasFormat(TransferableFormats.URL_FORMAT)) {
                var url:String=String(data.dataForFormat(
                    TransferableFormats.URL_FORMAT)); 
				
				var img:Image = new Image();
				img.load(url);
				addImage(img);
            }
            //ファイル
            else if(data.hasFormat(TransferableFormats.FILE_LIST_FORMAT)) {
                var dropfiles:Array=data.dataForFormat(
                    TransferableFormats.FILE_LIST_FORMAT) as Array;
                for each (var file:File in dropfiles) {
					var img:Image = new Image();
					img.load(file.url);
					addImage(img);
                }
            }
        }
        
        private function addImage(img: Image): void {

        	img.width  = 160;
        	img.height = 160;
        	
        	img.addEventListener(MouseEvent.MOUSE_DOWN, onImageDblClk);
			window.imageList.addChild(img);
        }
        
		public function onImageDblClk (e:MouseEvent):void {
			window.imageList.removeChild(e.currentTarget as DisplayObject);
		}

 	}
}