package mixi
{
	import mx.containers.Form;
	import flash.html.HTMLControl;
	import mx.controls.Alert;
	import mx.core.Container;
	import flash.display.DisplayObject;
	import mx.effects.Fade;
	import flash.net.URLRequest;
	import mx.core.Window;
	
	public class LoginForm
	{
		public var onLoginSucceed:Function;

		private var loginForm:LoginFormUI;
		private var handler:LoginFormHandler;
		private var browser:Browser;
		private var parent:Container;

		public function LoginForm(parent:Container, browser:Browser):void {
			this.parent = parent;
			this.browser = browser;
			this.loginForm = new LoginFormUI();
			this.handler = loginForm.handler;

			handler.onLoginHandler = onLogin;
			
		}

		public function showLoginForm(): void {
			var d: DisplayObject = parent.addChild(loginForm);

			d.x = (parent.width-loginForm.width)/2
			d.y = (parent.height-loginForm.height)/2
			var fade:Fade = new Fade();
			fade.alphaFrom = 0;
			fade.alphaTo   = 1;
			fade.duration  = 300;
			
			var targets: Array = loginForm.getChildren();
			targets.push(d);
			fade.play(targets);
			loginForm.visible = true;
		}

		public function onLogin(email: String, password: String):void {
			parent.removeChild(loginForm);
			
			var req: URLRequest = new URLRequest("https://mixi.jp/login.pl");
			req.method = "POST";
			req.contentType = "text";
			req.data = "email=" + escape(email) + "&" + "password=" + escape(password) + "&next_url=/home.pl";

			browser.sendMessage(new MixiRequest(req, MixiLoginMessage, function(m:MixiLoginMessage) {
				if (m.isLoginSucceed()) {
					onLoginSucceed();
				} else {
					showLoginForm();
				}
			}));
		}
	}


}